Subject: bug#62720: 29.0.60; Not easy at all to upgrade :core packages like Eglot

From: Eli Zaretskii <[email-masked]>
Date: Wed, 12 Apr 2023 18:59:19 +0300

> Date: Wed, 12 Apr 2023 18:49:09 +0300
> Cc: [email-masked], [email-masked], [email-masked],
>  [email-masked]
> From: Dmitry Gutov <[email-masked]>
> 
> On 12/04/2023 14:08, Eli Zaretskii wrote:
> >> From: João Távora<[email-masked]>
> >> Cc:[email-masked],[email-masked],[email-masked],
> >>    [email-masked]
> >> Date: Wed, 12 Apr 2023 12:00:04 +0100
> >>
> >> Had another idea: what about this very tiny patch, then?  It makes `M-x
> >> package-install` work for installing a :core package.  This also rhymes
> >> exactly with Stefan's intution/feeling that :core packages need to be
> >> "installed" to promote them to installable.  The current M-x
> >> package-install recommendation could remain flawlessly and then you can
> >> do whatever you think is best for M-x package-update & friends.
> > This has the same problem: it modifies a function that is called in
> > too many places.  package-installed-p has half a dozen callers in
> > package.el alone.  The change is tiny, but what about its
> > implications on every use case where it is involved?
> 
> What if we only fix 'package-upgrade' (nee package-update) in emacs-29?

I believe that's what João was proposing.

I don't mind, but changes in package-update will also need to be safe
enough, since this command, while new in Emacs 29, is with us for the
last year, so is relatively well tested, and I don't want to risk
breaking it by last-minute changes of a non-trivial nature.